﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace pl3w
{
    public partial class FormSetup : Form
    {
        //public SetupInfo setupVal;

        private SetupVal setupVal;


        public SetupVal SetupVal { 
            get => setupVal; 
            set => setupVal = new SetupVal(value); 
        }

        public FormSetup()
        {
            InitializeComponent();
        }

        private void FormSetup_Load(object sender, EventArgs e)
        {
            setupVal.CheckValue();
            SetItems();
            SetCheckStatus();
        }


        private void SetItems()
        {
            textBoxStartLine.Text = setupVal.startLine.ToString();
            textBoxColumnStatus.Text = setupVal.colStatus;
            textBoxColumnName.Text = setupVal.colPN;
            textBoxColumnRefPrefix.Text = setupVal.colPrefix;
            textBoxColumnRefSuffix.Text = setupVal.colSuffix;
            textBoxColumnMnf.Text = setupVal.colMnf;
            textBoxColumnMnfPN.Text = setupVal.colMnfPN;
            textBoxColumnPkg.Text = setupVal.colPkg;
            textBoxColumnNote.Text = setupVal.colNote;
            textBoxColumnCompInfo.Text = setupVal.colCompInfo;
            textBoxColumnPage.Text = setupVal.colPage;
            textBoxColumnPos.Text = setupVal.colPos;
            textBoxColumnFileName.Text = setupVal.colFileName;

            checkBoxMnf.Checked = setupVal.enMnf;
            checkBoxMnfPN.Checked = setupVal.enMnfPN;
            checkBoxPackage.Checked = setupVal.enPkg;
            checkBoxNote.Checked = setupVal.enNote;
            checkBoxCompInfo.Checked = setupVal.enCompInfo;
            checkBoxPage.Checked = setupVal.enPage;
            checkBoxPosition.Checked = setupVal.enPos;
            checkBoxFileName.Checked = setupVal.enFileName;

            checkBoxPlaceLabel.Checked = setupVal.placeLabel;

            textBoxLabelStatus.Text = setupVal.titleStatus;
            textBoxLabelName.Text = setupVal.titlePN;
            textBoxLabelRefPrefix.Text = setupVal.titlePrefix;
            textBoxLabelRefSuffix.Text = setupVal.titleSuffix;
            textBoxLabelMnf.Text = setupVal.titleMnf;
            textBoxLabelMnfPN.Text = setupVal.titleMnfPN;
            textBoxLabelPkg.Text = setupVal.titlePkg;
            textBoxLabelNote.Text = setupVal.titleNote;
            textBoxLabelCompInfo.Text = setupVal.titleCompInfo;
            textBoxLabelPage.Text = setupVal.titlePage;
            textBoxLabelPos.Text = setupVal.titlePos;
            textBoxLabelFileName.Text = setupVal.titleFileName;


        }

        private void ReadItems()
        {
            int n;
            if(!int.TryParse(textBoxStartLine.Text, out n))
            {
                n = 0;
            }
            setupVal.startLine = n;

            setupVal.colStatus = textBoxColumnStatus.Text;
            setupVal.colPN = textBoxColumnName.Text;
            setupVal.colPrefix = textBoxColumnRefPrefix.Text;
            setupVal.colSuffix = textBoxColumnRefSuffix.Text;
            setupVal.colMnf = textBoxColumnMnf.Text;
            setupVal.colMnfPN = textBoxColumnMnfPN.Text;
            setupVal.colPkg = textBoxColumnPkg.Text;
            setupVal.colNote = textBoxColumnNote.Text;
            setupVal.colCompInfo = textBoxColumnCompInfo.Text;
            setupVal.colPage = textBoxColumnPage.Text;
            setupVal.colPos = textBoxColumnPos.Text;
            setupVal.colFileName = textBoxColumnFileName.Text;

            setupVal.enMnf = checkBoxMnf.Checked;
            setupVal.enMnfPN = checkBoxMnfPN.Checked;
            setupVal.enPkg = checkBoxPackage.Checked;
            setupVal.enNote = checkBoxNote.Checked;
            setupVal.enCompInfo = checkBoxCompInfo.Checked;
            setupVal.enPage = checkBoxPage.Checked;
            setupVal.enPos = checkBoxPosition.Checked;
            setupVal.enFileName = checkBoxFileName.Checked;

            setupVal.placeLabel = checkBoxPlaceLabel.Checked;

            setupVal.titleStatus = textBoxLabelStatus.Text;
            setupVal.titlePN = textBoxLabelName.Text;
            setupVal.titlePrefix = textBoxLabelRefPrefix.Text;
            setupVal.titleSuffix = textBoxLabelRefSuffix.Text;
            setupVal.titleMnf = textBoxLabelMnf.Text;
            setupVal.titleMnfPN = textBoxLabelMnfPN.Text;
            setupVal.titlePkg = textBoxLabelPkg.Text;
            setupVal.titleNote = textBoxLabelNote.Text;
            setupVal.titleCompInfo = textBoxLabelCompInfo.Text;
            setupVal.titlePage = textBoxLabelPage.Text;
            setupVal.titlePos = textBoxLabelPos.Text;
            setupVal.titleFileName = textBoxLabelFileName.Text;


        }


        private void SetCheckStatus()
        {
           
            textBoxStartLine.BackColor = (setupVal.err_startLine ? Color.Orange : SystemColors.Window);
            textBoxColumnStatus.BackColor = (setupVal.err_colStatus ? Color.Orange : SystemColors.Window);
            textBoxColumnRefPrefix .BackColor = (setupVal.err_colPrefix ? Color.Orange : SystemColors.Window);
            textBoxColumnRefSuffix.BackColor = (setupVal.err_colSuffix ? Color.Orange : SystemColors.Window);
            textBoxColumnName.BackColor = (setupVal.err_colPN ? Color.Orange : SystemColors.Window);
            textBoxColumnMnf.BackColor = (setupVal.err_colMnf ? Color.Orange : SystemColors.Window);
            textBoxColumnMnfPN.BackColor = (setupVal.err_colMnfPN ? Color.Orange : SystemColors.Window);
            textBoxColumnPkg.BackColor = (setupVal.err_colPkg ? Color.Orange : SystemColors.Window);
            textBoxColumnNote.BackColor = (setupVal.err_colNote ? Color.Orange : SystemColors.Window);
            textBoxColumnCompInfo.BackColor = (setupVal.err_colCompInfo ? Color.Orange : SystemColors.Window);
            textBoxColumnPage.BackColor = (setupVal.err_colPage? Color.Orange : SystemColors.Window);
            textBoxColumnPos.BackColor = (setupVal.err_colPos?  Color.Orange : SystemColors.Window);
            textBoxColumnFileName.BackColor = (setupVal.err_colFileName?  Color.Orange : SystemColors.Window);


        }

        private void IDOK_Click(object sender, EventArgs e)
        {
            ReadItems();
            if (!setupVal.CheckValue())
            {
                SetCheckStatus();
                return;
            }

            DialogResult = DialogResult.OK;
        }
    }
}
